Subject: bug#56535: 28.1; `no' and `no-ding' values for isearch-wrap-pause option (since Emacs 28.1) not working as documented

From: Juri Linkov <[email-masked]>
Date: Mon, 01 Aug 2022 20:55:43 +0300

>> Currently this is documented in the Info node
>> (info "(emacs) Repeat Isearch"):
>>
>>      You can control what happens when there are no more matches by
>>   customizing the ‘isearch-wrap-pause’ user option.  If it is ‘t’ (the
>>   default), signal an error.  (Repeating the search will wrap around.)  If
>>   ‘no’, issue a ‘ding’ and wrap immediately after reaching the last match.
>>   If ‘no-ding’, wrap immediately, but don’t ‘ding’.  Finally, if ‘nil’,
>>   never wrap, but just stop at the last match.
>>
>> The problem is that everything in this Info node is about
>> repeating the search with `C-s C-s'.  I can't find a suitable place
>> to describe the additional incremental wrapping here.
>
> Why is this node not appropriate for whatever you want to document?
>
> Or maybe I don't have a clear idea of what you want to add there?

The new additional behavior of ‘no’ and ‘no-ding’ is to wrap on appending
a character to the search string.  Maybe then something like this:

diff --git a/doc/emacs/search.texi b/doc/emacs/search.texi
index 27d4db8541..7cf3a3f5a9 100644
--- a/doc/emacs/search.texi
+++ b/doc/emacs/search.texi
@@ -228,8 +228,9 @@ Repeat Isearch
 @code{t} (the default), signal an error.  (Repeating the search will
 wrap around.)  If @code{no}, issue a @code{ding} and wrap immediately
 after reaching the last match.  If @code{no-ding}, wrap immediately,
-but don't @code{ding}.  Finally, if @code{nil}, never wrap, but just
-stop at the last match.
+but don't @code{ding}.  With the values @code{ding} and @code{no-ding}
+the search will try to wrap around also on typing a character.
+Finally, if @code{nil}, never wrap, but just stop at the last match.